/* \file fml_constants.f90
 * constants definition
 */
 
#ifndef _FML_CONSTANTS_H_
#define _FML_CONSTANTS_H_

#define stop_arith 100
#define stop_div0  101 
#define stop_sqrt  102 

#define stop_overflow 200
#define stop_array_indice_exceed  201 
#define stop_array_compatible 202
#define stop_array_diag_compatible 203

#define stop_array_singular 300
#define stop_array_diverge 301
#define stop_array_symmetric 302
#define stop_array_positive 304
#define stop_array_factorisation 305

#define stop_method_exist 400

#define stop_std 1100
#define stop_err 1101 
#define stop_tst 1102

#define stop_aloc 2001 
#define stop_dealoc 2002 

#define stop_open_file 3001
#define stop_write_file 3011 




#define OMP_NUM_THREADS 2

#define use_type /* if use_type define, type_precision=real */

#ifdef use_type /* simple precision*/
#define type_precision real*4
#define mpi_type_precision MPI_REAL
#define p_abs abs
#define p_sqrt sqrt
#define p_cast dble
#define p_dble dble
#define p_sngl real
#define p_notcast real
#define p_un 1.0
#define p_mun -1.0
#define p_eps 1.e-16
#define p_iter_eps 1.e-7
#define p_fmt_file '(f0.8)'
#else /* double precision*/
#define type_precision real*8
#define mpi_type_precision MPI_REAL8 
#define p_abs dabs
#define p_sqrt dsqrt
#define p_cast real
#define p_dble dble
#define p_sngl real
#define p_notcast dble
#define p_un 1.d0
#define p_mun -1.d0
#define p_eps 1.e-16
#define p_iter_eps 1.e-9
#define p_fmt_file '(f0.16)'
#endif

#define len_what_exception 100

#define DEBUGPRINT(txtmsg,msg) write(*,*),'txtmsg',':',msg 
#define DEBUGPRINT_MPI(txtmsg,msg,myrank) write(*,*),'txtmsg',':',msg,myrank 

/* #define XDEBUG_EXCEPTION  for non debug mode */
#define DEBUG_EXCEPTION  /* for debug mode */

/*  MPI specification  */
#define MASTER_ID 0


#include "fml_timing.h"

#include "fml_debug.h"


#endif
